
from scipy import *
from pylab import *
import time
import sys

def set_circle(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 if (x**2+y**2) > r**2: continue
	 arr[center[0]+x,center[1]+y] = value
   return

def circle_mask(size,center,r):
   arr = zeros(size)
   set_circle(arr,1.0,center,r)
   return arr

def set_square(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 arr[center[0]+x,center[1]+y] = value
   return




 
def make_anis_filter1(sigsq,nx,ny,anis): 
   inv = 1/(2.0*sigsq)
   filtery = matrix(array([(exp(-(x**2*(1+anis*x**2))*inv) + exp(-((ny-x)**2*(1+anis*(ny-x)**2)*inv))) for x in range(ny)],dtype=float))
   normy = sum(filtery)
   filtery = filtery/normy

   filterx = matrix(array([(exp(-(x**2*(1+anis*x**2))*inv) + exp(-((nx-x)**2*(1+anis*(nx-x)**2)*inv))) for x in range(nx)],dtype=float))
   normx = sum(filterx)
   filtery = filtery/normx
   filterx = transpose(filterx)
   return fft2(array(filterx*filtery))
  
def make_anis_filter(sigsq,nx,ny,anis): 
   filter = zeros((nx,ny))
   filter1 = zeros((nx,ny))
   inv = 1/(2.0*sigsq)
   for x in range(nx):
      for y in range(ny):
	 filter1[x,y] = exp(-inv*(x**2+y**2 + 0.25*anis*((x-y)**4 + (x+y)**4)))
   filter = filter1+0# the zero makes this a new reference

   for x in range(1,nx):
      for y in range(0,ny):
            filter[x,y] += filter1[nx-x,y] 

   for x in range(0,nx):
      for y in range(1,ny):
            filter[x,y] += filter1[x,ny-y] 

   for x in range(1,nx):
      for y in range(1,ny):
            filter[x,y] += filter1[nx-x,ny-y] 

   norm = sum(filter)
   filter = filter/norm
   return fft2(filter)
   

def make_gauss_filter(sigsq,nx,ny): 
   return make_anis_filter(sigsq,nx,ny,0)
  


nx = 512
ny = 512
dt = 0.05
T0 = -1.0 
a= T0
b = -1.0 
Dphi = 7.0
DT = 7.0
C=0.5
gamma = 2.0

#p = zeros((nx,ny),dtype=float)
#p[0,n-1]= p[1,0]= p[n-1,0]= p[0,1]=dt*Du*0.25
#p[0,0] = (1-dt*Du)
#filter_u = fft2(p)
#p[0,n-1]= p[1,0]= p[n-1,0]= p[0,1]=dt*Dv*0.25
#p[0,0] = (1-dt*Dv)
#filter_v = fft2(p)




ion()

#A = make_anis_filter(1.0,4,4,0.0)
filter_phi = make_anis_filter1(2*Dphi*dt,nx,ny,2.0)
#imshow(real(ifft2(filter_phi)))
show()
filter_T = make_gauss_filter(2*DT*dt,nx,ny)

dims = (nx,ny)

dphi = zeros((nx,ny))
T = a*ones(dims,dtype=float)
phi = b*ones(dims,dtype=float)
set_square(phi,1.0,(nx/2,ny/2),4)
set_square(T,0.0,(nx/2,ny/2),4)
T += 0.01*standard_normal(dims)
phi += 0.01*standard_normal(dims)

c_mask = circle_mask(dims,(nx/2,ny/2),nx/2-10)

for k in range(50000):
   Tk = fft2(T)
   Tk = Tk*filter_T
   T = real(ifft2(Tk))

   #T[:,ny-10:] = T0
   #T[:,0:10] =  T0
   #T[0:10,:]=   T0
   #T[nx-10:,:]=  T0

   T = T*c_mask + T0*(1-c_mask)


   phik = fft2(phi)
   phik = phik*filter_phi
   phi = real(ifft2(phik))

   #V = (phi*(phi-1)^2 + (T-1)*phi^2
   #dphi =  -dt*gamma*(2*phi*(phi-1)*(2*phi-1) + 2*(T-1)*phi)
   #V = (phi^2-1)^2 + T*phi
   dphi =  -dt*gamma*(4*phi*(phi*phi-1)+T)
   phi += dphi
   T +=  C*dphi
   if (k%100 == 0): 
      imshow(phi)
      #plot(phi[:,ny/2])
      #plot(T[:,ny/2])
      #cla()
      show()
      if (phi[nx/5,ny/5] > 0.2): break


      show()

